

<!DOCTYPE html>

<html lang="ja">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>7.8.2. TokenBigram &#8212; Groonga v10.1.1-31-g1e46ba6ドキュメント</title>
    <link rel="stylesheet" href="../../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script src="../../_static/language_data.js"></script>
    <script src="../../_static/translations.js"></script>
    
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
    <link rel="index" title="索引" href="../../genindex.html" />
    <link rel="search" title="検索" href="../../search.html" />
    <link rel="next" title="7.8.3. TokenBigramIgnoreBlank" href="token_bigram_ignore_blank.html" />
    <link rel="prev" title="7.8.1. 概要" href="../tokenizer/summary.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">オープンソースのカラムストア機能付き全文検索エンジン</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../../en/html/reference/tokenizers/token_bigram.html">English</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="総合索引"
             accesskey="I">索引</a></li>
        <li class="right" >
          <a href="token_bigram_ignore_blank.html" title="7.8.3. TokenBigramIgnoreBlank"
             accesskey="N">次へ</a> |</li>
        <li class="right" >
          <a href="../tokenizer/summary.html" title="7.8.1. 概要"
             accesskey="P">前へ</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6ドキュメント</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>リファレンスマニュアル</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../tokenizers.html" accesskey="U"><span class="section-number">7.8. </span>トークナイザー</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.8.2. </span><code class="docutils literal notranslate"><span class="pre">TokenBigram</span></code></a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="tokenbigram">
<span id="token-bigram"></span><h1><span class="section-number">7.8.2. </span><code class="docutils literal notranslate"><span class="pre">TokenBigram</span></code><a class="headerlink" href="#tokenbigram" title="このヘッドラインへのパーマリンク">¶</a></h1>
<div class="section" id="summary">
<h2><span class="section-number">7.8.2.1. </span>概要<a class="headerlink" href="#summary" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">TokenBigram</span></code> はバイグラムベースのトークナイザーです。多くのケースでは、このトークナイザーを使うことをオススメします。</p>
<p>バイグラムというトークナイズ方法は、隣り合った2つの文字を1つのトークンとしてテキストをトークナイズします。例えば、 <code class="docutils literal notranslate"><span class="pre">Hello</span></code> は次のトークンにトークナイズします。</p>
<blockquote>
<div><ul class="simple">
<li><p><code class="docutils literal notranslate"><span class="pre">He</span></code></p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">el</span></code></p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">ll</span></code></p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">lo</span></code></p></li>
</ul>
</div></blockquote>
<p>バイグラムというトークナイズ方法は再現性に優れています。なぜなら、2文字以上の文字のクエリーに対してはすべてのテキストを見つけることができるからです。</p>
<p>一般的に、1文字のクエリーではすべてのテキストを見つけることはできません。なぜなら、1つの文字のトークンが存在しないからです。しかし、Groongaでは1文字のクエリーでもすべてのテキストを見つけることができます。なぜなら、Groongaは前方一致検索によりクエリーで指定した文字で始まるトークンをすべて見つけることができるからです。例えば、Groongaは <code class="docutils literal notranslate"><span class="pre">l</span></code> というクエリーから <code class="docutils literal notranslate"><span class="pre">ll</span></code> というトークンと <code class="docutils literal notranslate"><span class="pre">lo</span></code> というトークンを見つけることができます。</p>
<p>バイグラムというトークナイズ方法は適合率はそれほど優れていません。なぜなら、単語の一部にクエリーが含まれていればすべてのテキストが見つかってしまうからです。例えば、 <code class="docutils literal notranslate"><span class="pre">or</span></code> で <code class="docutils literal notranslate"><span class="pre">world</span></code> が見つかります。これは非ASCIIを使う言語よりASCIIのみを使う言語で顕著です。以降の説明で触れる通り、 <code class="docutils literal notranslate"><span class="pre">TokenBigram</span></code> はこの問題を解決しています。</p>
</div>
<div class="section" id="syntax">
<h2><span class="section-number">7.8.2.2. </span>構文<a class="headerlink" href="#syntax" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">TokenBigram</span></code> には、引数がありません。</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>TokenBigram
</pre></div>
</div>
</div>
<div class="section" id="usage">
<h2><span class="section-number">7.8.2.3. </span>使い方<a class="headerlink" href="#usage" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">TokenBigram</span></code> の挙動は <a class="reference internal" href="../normalizers.html"><span class="doc">ノーマライザー</span></a> を使うかどうかで変わります。</p>
<p>ノーマライザーを使っていない場合は <code class="docutils literal notranslate"><span class="pre">TokenBigram</span></code> は純粋なバイグラム（最後のトークンをのぞいてすべてのトークンを2文字にする）のトークナイズ方法を使います。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>tokenize TokenBigram &quot;Hello World&quot;
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     {
#       &quot;position&quot;: 0,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;He&quot;
#     },
#     {
#       &quot;position&quot;: 1,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;el&quot;
#     },
#     {
#       &quot;position&quot;: 2,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ll&quot;
#     },
#     {
#       &quot;position&quot;: 3,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;lo&quot;
#     },
#     {
#       &quot;position&quot;: 4,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;o &quot;
#     },
#     {
#       &quot;position&quot;: 5,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot; W&quot;
#     },
#     {
#       &quot;position&quot;: 6,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;Wo&quot;
#     },
#     {
#       &quot;position&quot;: 7,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;or&quot;
#     },
#     {
#       &quot;position&quot;: 8,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;rl&quot;
#     },
#     {
#       &quot;position&quot;: 9,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ld&quot;
#     },
#     {
#       &quot;position&quot;: 10,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;d&quot;
#     }
#   ]
# ]
</pre></div>
</div>
<p>ノーマライザーを使っている場合は <code class="docutils literal notranslate"><span class="pre">TokenBigram</span></code> はASCIIの文字には空白区切りのようなトークナイズ方法を使います。非ASCII文字にはバイグラムのトークナイズ方法を使います。</p>
<p>もしかしたら、複数の方法が混ざったこの挙動はわかりにくいかもしれません。しかし、英語のテキスト（ASCII文字列のみ）や日本語テキスト（ASCII文字列と非ASCII文字列が混ざっている）ような多くのユースケースでは合理的な方法です。</p>
<p>ASCII文字しか使わない多くの言語は単語の区切りに空白文字を使っています。このようなケースに空白区切りのトークナイズ方法は適切です。</p>
<p>非ASCII文字を使う言語では単語の区切りに空白文字を使いません。このケースにはバイグラムなトークナイズ方法は適切です。</p>
<p>複数の言語が混ざっている場合は、複数の方法を組み合わせたトークナイズ方法が適切です。</p>
<p>ASCII文字にバイグラムなトークナイズ方法を使いたい場合は <a class="reference internal" href="token_bigram_split_symbol_alpha.html#token-bigram-split-symbol-alpha"><span class="std std-ref">TokenBigramSplitSymbolAlpha</span></a> のような <code class="docutils literal notranslate"><span class="pre">TokenBigramSplitXXX</span></code> というトークナイザーを参照してください。</p>
<p>例を使いながら <code class="docutils literal notranslate"><span class="pre">TokenBigram</span></code> の挙動を確認しましょう。</p>
<p><code class="docutils literal notranslate"><span class="pre">TokenBigram</span></code> はASCII文字には1つ以上の空白文字をトークンの区切りとして使います。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>tokenize TokenBigram &quot;Hello World&quot; NormalizerAuto
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     {
#       &quot;position&quot;: 0,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;hello&quot;
#     },
#     {
#       &quot;position&quot;: 1,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;world&quot;
#     }
#   ]
# ]
</pre></div>
</div>
<p><code class="docutils literal notranslate"><span class="pre">TokenBigram</span></code> はASCII文字には文字の種類が変わったところをトークンの区切りとします。文字の種類は次のどれかです。</p>
<blockquote>
<div><ul class="simple">
<li><p>アルファベット</p></li>
<li><p>数字</p></li>
<li><p>記号（たとえば <code class="docutils literal notranslate"><span class="pre">(</span></code> 、 <code class="docutils literal notranslate"><span class="pre">)</span></code> 、 <code class="docutils literal notranslate"><span class="pre">!</span></code> など）</p></li>
<li><p>ひらがな</p></li>
<li><p>カタカナ</p></li>
<li><p>漢字</p></li>
<li><p>その他</p></li>
</ul>
</div></blockquote>
<p>次の例は2つのトークン区切りを示しています。</p>
<blockquote>
<div><ul class="simple">
<li><p><code class="docutils literal notranslate"><span class="pre">100</span></code> （数字）と <code class="docutils literal notranslate"><span class="pre">cents</span></code> （アルファベット）の間のところ</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">cents</span></code> （アルファベット）と <code class="docutils literal notranslate"><span class="pre">!!!</span></code> （記号）の間のところ</p></li>
</ul>
</div></blockquote>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>tokenize TokenBigram &quot;100cents!!!&quot; NormalizerAuto
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     {
#       &quot;position&quot;: 0,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;100&quot;
#     },
#     {
#       &quot;position&quot;: 1,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;cents&quot;
#     },
#     {
#       &quot;position&quot;: 2,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;!!!&quot;
#     }
#   ]
# ]
</pre></div>
</div>
<p>以下は <code class="docutils literal notranslate"><span class="pre">TokenBigram</span></code> が非ASCII文字にはトークナイズ方法としてバイグラムを使う例です。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>tokenize TokenBigram &quot;日本語の勉強&quot; NormalizerAuto
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     {
#       &quot;position&quot;: 0,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;日本&quot;
#     },
#     {
#       &quot;position&quot;: 1,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;本語&quot;
#     },
#     {
#       &quot;position&quot;: 2,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;語の&quot;
#     },
#     {
#       &quot;position&quot;: 3,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;の勉&quot;
#     },
#     {
#       &quot;position&quot;: 4,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;勉強&quot;
#     },
#     {
#       &quot;position&quot;: 5,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;強&quot;
#     }
#   ]
# ]
</pre></div>
</div>
</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../../index.html">目次</a></h3>
  <ul>
<li><a class="reference internal" href="#">7.8.2. <code class="docutils literal notranslate"><span class="pre">TokenBigram</span></code></a><ul>
<li><a class="reference internal" href="#summary">7.8.2.1. 概要</a></li>
<li><a class="reference internal" href="#syntax">7.8.2.2. 構文</a></li>
<li><a class="reference internal" href="#usage">7.8.2.3. 使い方</a></li>
</ul>
</li>
</ul>

  <h4>前のトピックへ</h4>
  <p class="topless"><a href="../tokenizer/summary.html"
                        title="前の章へ"><span class="section-number">7.8.1. </span>概要</a></p>
  <h4>次のトピックへ</h4>
  <p class="topless"><a href="token_bigram_ignore_blank.html"
                        title="次の章へ"><span class="section-number">7.8.3. </span><code class="docutils literal notranslate"><span class="pre">TokenBigramIgnoreBlank</span></code></a></p>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">クイック検索</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="検索" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="総合索引"
             >索引</a></li>
        <li class="right" >
          <a href="token_bigram_ignore_blank.html" title="7.8.3. TokenBigramIgnoreBlank"
             >次へ</a> |</li>
        <li class="right" >
          <a href="../tokenizer/summary.html" title="7.8.1. 概要"
             >前へ</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6ドキュメント</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>リファレンスマニュアル</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../tokenizers.html" ><span class="section-number">7.8. </span>トークナイザー</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.8.2. </span><code class="docutils literal notranslate"><span class="pre">TokenBigram</span></code></a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>